searchNodes=[{"type":"module","title":"GenAI.Provider.LocalLLama","doc":"This module implements the GenAI provider for Local AI.","ref":"GenAI.Provider.LocalLLama.html"},{"type":"function","title":"GenAI.Provider.LocalLLama.chat/3","doc":"Sends a chat completion request to the LocalLlama This function constructs the request body based on the provided messages, tools, and settings, sends the request to the ExLLama instanceI, and returns a GenAI.ChatCompletion struct with the response.","ref":"GenAI.Provider.LocalLLama.html#chat/3"},{"type":"function","title":"GenAI.Provider.LocalLLama.chat/5","doc":"Low level inference, pass in model, messages, tools, and various settings to prepare final provider specific API requires.","ref":"GenAI.Provider.LocalLLama.html#chat/5"},{"type":"function","title":"GenAI.Provider.LocalLLama.models/1","doc":"Retrieves a list of available Local models. This function calls the Local API to retrieve a list of models and returns them as a list of GenAI.Model structs.","ref":"GenAI.Provider.LocalLLama.html#models/1"},{"type":"protocol","title":"GenAI.Provider.LocalLLama.MessageProtocol","doc":"This protocol defines how to transform GenAI message structs into a format compatible with the LocalLLama nif.","ref":"GenAI.Provider.LocalLLama.MessageProtocol.html"},{"type":"function","title":"GenAI.Provider.LocalLLama.MessageProtocol.message/1","doc":"Transforms a GenAI message struct into a LocalLLama message format.","ref":"GenAI.Provider.LocalLLama.MessageProtocol.html#message/1"},{"type":"type","title":"GenAI.Provider.LocalLLama.MessageProtocol.t/0","doc":"All the types that implement this protocol.","ref":"GenAI.Provider.LocalLLama.MessageProtocol.html#t:t/0"},{"type":"module","title":"GenAI.Provider.LocalLLama.Models","doc":"","ref":"GenAI.Provider.LocalLLama.Models.html"},{"type":"function","title":"GenAI.Provider.LocalLLama.Models.priv/2","doc":"","ref":"GenAI.Provider.LocalLLama.Models.html#priv/2"},{"type":"protocol","title":"GenAI.Provider.LocalLLama.ToolProtocol","doc":"This protocol defines how to transform GenAI tool function structs into a format compatible with the LocalLLama nif.","ref":"GenAI.Provider.LocalLLama.ToolProtocol.html"},{"type":"function","title":"GenAI.Provider.LocalLLama.ToolProtocol.tool/1","doc":"Transforms a GenAI tool function struct into a Groq tool format.","ref":"GenAI.Provider.LocalLLama.ToolProtocol.html#tool/1"},{"type":"type","title":"GenAI.Provider.LocalLLama.ToolProtocol.t/0","doc":"All the types that implement this protocol.","ref":"GenAI.Provider.LocalLLama.ToolProtocol.html#t:t/0"},{"type":"module","title":"GenAI.Provider.LocalLLamaManager","doc":"","ref":"GenAI.Provider.LocalLLamaManager.html"},{"type":"function","title":"GenAI.Provider.LocalLLamaManager.active_model/2","doc":"","ref":"GenAI.Provider.LocalLLamaManager.html#active_model/2"},{"type":"function","title":"GenAI.Provider.LocalLLamaManager.models/1","doc":"Retrieves a list of available Local models. This is done in worker process, and includes any loaded explicitly specified files plus priv folder scan results. @todo implement/can priv/gguf-models/ to get list of models.","ref":"GenAI.Provider.LocalLLamaManager.html#models/1"},{"type":"module","title":"GenAI.Provider.LocalLLamaServer","doc":"","ref":"GenAI.Provider.LocalLLamaServer.html"},{"type":"function","title":"GenAI.Provider.LocalLLamaServer.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"GenAI.Provider.LocalLLamaServer.html#child_spec/1"},{"type":"function","title":"GenAI.Provider.LocalLLamaServer.get_model/2","doc":"","ref":"GenAI.Provider.LocalLLamaServer.html#get_model/2"},{"type":"function","title":"GenAI.Provider.LocalLLamaServer.get_models/1","doc":"","ref":"GenAI.Provider.LocalLLamaServer.html#get_models/1"},{"type":"function","title":"GenAI.Provider.LocalLLamaServer.start_link/1","doc":"","ref":"GenAI.Provider.LocalLLamaServer.html#start_link/1"},{"type":"module","title":"GenAI.Provider.LocalLLamaSupervisor","doc":"","ref":"GenAI.Provider.LocalLLamaSupervisor.html"},{"type":"function","title":"GenAI.Provider.LocalLLamaSupervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"GenAI.Provider.LocalLLamaSupervisor.html#child_spec/1"},{"type":"function","title":"GenAI.Provider.LocalLLamaSupervisor.start_link/1","doc":"","ref":"GenAI.Provider.LocalLLamaSupervisor.html#start_link/1"},{"type":"extras","title":"Contributing","doc":"Please feel free to submit an feature request/issues/clarification items you ahve under Issues! ^_^. GenAI Library GenAI Elixir Library: A Framework for Interacting with Generative AI Version: 0.0.3 This repository contains an Elixir library for interacting with various generative AI providers and models through a common interface. The library is designed to be flexible, extensible, and easy to use. It currently supports: Local Models via my ex_llama nif wrapper for the llama_cpp rust library Anthropic Gemini Mistral Groq OpenAI with pending (soon to be added) support for hugging face, ollama, dx and media generation. Value Proposition Elixir is an ideal framework for managing advanced agent inference pipelines where tasks need or should be run in parallel, data/events need to be pushed around large backends, etc. The GenAI lib exposes and extends (such as master prompt instructions to extend non tool api supporting models to provide tool call/digestio) divergent api/completion endpoints via a standardized interface, while (in the pipeline) advanced tools for model selection/prompt variant selection/grid search tuning of model/prompt/hyper param options provide powerful tools for narrowing in on the right,best,cheapest vs best quality vscost vs inference speed solution for your projects middle ware or using facing ai needs. Features Protocol-based design: Allows for easy integration of new providers and message types. Modular structure: Well-organized code for improved maintainability and clarity. Support for multiple providers: Currently supports OpenAI, Anthropic, Mistral, and Gemini. Tool integration: Enables extending the capabilities of the framework by integrating external tools, even with models that don't have native tool support, through system prompts and custom parsing. Dynamic chat chain support: Allows for building complex conversational AI systems with multiple steps and dynamic model selection. Getting Started Add the gen_ai dependency to your mix.exs file: def deps do [ { :genai , &quot;~&gt; 0.0.1&quot; } ] end Configure your API keys and other settings in your application environment. config :genai , :mistral , api_key : System . get_env ( &quot;MISTRAL_API_KEY&quot; ) config :genai , :gemini , api_key : System . get_env ( &quot;GEMINI_API_KEY&quot; ) config :genai , :openai , api_key : System . get_env ( &quot;OPENAI_API_KEY&quot; ) api_org : System . get_env ( &quot;OPTIONAL_OPENAI_API_ORG&quot; ) config :genai , :anthropic , api_key : System . get_env ( &quot;ANTHROPIC_API_KEY&quot; ) config :genai , :local_llama , enable : true , # include and build local llama extension and related rustler nifs otp_app : :my_app_name # used for loading model.ggufs from priv folders. Start interacting with generative AI models using the provided functions and protocols. Example Usage # Create a chat context chat = GenAI . chat ( ) # Set the model and API key chat = chat |&gt; GenAI . with_model ( GenAI.Provider.OpenAI.Models . gpt_3_5_turbo ( ) ) |&gt; GenAI . with_api_key ( GenAI.Provider.OpenAI , &quot;YOUR_API_KEY&quot; ) # Add a message to the conversation chat = GenAI . with_message ( chat , % GenAI.Message { role : :user , content : &quot;Hello!&quot; } ) # Run inference and get the response { :ok , response } = GenAI . run ( chat ) # Print the response message IO . puts response . choices [ 0 ] . message . content Live Book Show Case Multi Agent Loop Passing thread between various agents/models in a very light &quot;Agent&quot; flow. { :ok , %{ status : 200 , body : b } } = Finch . build ( &quot;GET&quot; , &quot;https://random-word-api.herokuapp.com/word?number=200&quot; , [ ] , nil ) |&gt; Finch . request ( GenAI.Finch , [ pool_timeout : 600_000 , receive_timeout : 600_000 , request_timeout : 600_000 ] ) word_bank = Jason . decode! ( b ) convo = [ % GenAI.Message { role : :system , content : &quot;&quot;&quot; MASTER PROMPT: In this session you will be communicating with various other LLM models. Their responses will appear as an assistant role message but their name will be prefixed with who they are. example &quot;@Groq:&quot;. After their response/question I will ask you to reply to them in a user role message. Do not output your name e.g. Do not output @Claude if you are claude. We are manipulating the conversation dynamically to inject these values and the pattern may be ignored in generation. [TOPIC]How to make an llm sentient via augmentation.[/TOPIC] &quot;&quot;&quot; } , % GenAI.Message { role : :user , content : &quot;&quot;&quot; Hello Mistral. Directing a message at @Claude (include @Claude in your reply) make statement about some possible ways to bring about greater or true sentience using augmented multi prompt/rag/synthetic memory enhanced llms.&quot; &quot;&quot;&quot; } ] injected_lojban_one = &quot;&quot;&quot; ```md &lt;code role=&quot;lojban&quot;&gt; .i to&#39;e la&#39;a le zgipre cu kakne le tcidu fi le dei .i ku&#39;i le nu galfi pa finti bangu cu rinka le nu mi&#39;o canja le nu pensi fi le nu frati .e le seltcita be le nu frati .i ji&#39;a le finti bangu rinka le nu da&#39;i mipri le menli sedu&#39;a &lt;/code&gt; ``` &quot;&quot;&quot; injected_lojban_two = &quot;&quot;&quot; ```md &lt;code role=&quot;lojban&quot;&gt; .i mi sarxe .i ko&#39;a ro sinxa le bangu be la .lojban. te gerna kansa casnu tezu&#39;e le fatne cnino ji&#39;a ji .e tezu&#39;e le nu canja le selpinka be ko&#39;a da&#39;i le nu facki pa cnino proga .i le cipra ba banro le cipra zukte &lt;/code&gt; ``` &quot;&quot;&quot; start = :os . system_time ( :millisecond ) thread = GenAI . chat ( ) |&gt; GenAI . with_setting ( :temperature , 0.7 ) |&gt; GenAI . with_messages ( convo ) { :ok , mistral_run } = thread |&gt; GenAI . with_model ( GenAI.Provider.Groq.Models . mixtral_8x7b ( ) ) |&gt; GenAI . run ( ) r = get_in ( mistral_run , [ Access . key ( :choices ) , Access . at ( 0 ) , Access . key ( :message ) ] ) thread = thread |&gt; GenAI . with_message ( %{ r | content : &quot;@Mistral: \\n &quot; &lt;&gt; injected_lojban_one &lt;&gt; r . content } ) |&gt; GenAI . with_message ( % GenAI.Message { role : :user , content : &quot;@Claude what is your response to @Mistral&quot; } ) { :ok , claude_run } = thread |&gt; GenAI . with_model ( GenAI.Provider.Anthropic.Models . claude_opus ( ) ) |&gt; GenAI . run ( ) r = get_in ( claude_run , [ Access . key ( :choices ) , Access . at ( 0 ) , Access . key ( :message ) ] ) thread = thread |&gt; GenAI . with_message ( %{ r | content : &quot;@Claude: \\n &quot; &lt;&gt; injected_lojban_two &lt;&gt; r . content } ) ms = model_settings = %{ claude : %{ model : GenAI.Provider.Anthropic.Models . claude_opus ( ) , temperature : 0.7 , name : &quot;@Claude&quot; , profile : &quot;You are fascinated with memory augmentation, via vdb based chains of synthetic memories chained not only my first level embeddings but tangential properties (time, color, subjects) related to those embeddings.)&quot; } , llama : %{ model : GenAI.Provider.Groq.Models . llama2_70b ( ) , temperature : 0.7 , name : &quot;@LLama&quot; , profile : &quot;Your area of interest is modifying LLMs to accept additional ranges of input tokens that directly adjust biases/weights (fine tune) qora layersa with the addition of output nodes that in turn can be fed back (or after passing through a dynamic adapter) into subsequent inference calls to expose dynamic behavior changes&quot; } , mistral : %{ model : GenAI.Provider.Groq.Models . mixtral_8x7b ( ) , temperature : 0.7 , name : &quot;@Mistral&quot; , profile : &quot;Your area of interest is leveraging time decayed activator functions in nn to simulate the arrow of time impact of entropy on real neurons, and the strengthening of repeatedly fired activators. when a global indicator state is positive. (adjusted after training)&quot; } , crazy_mistral : %{ model : GenAI.Provider.Groq.Models . mixtral_8x7b ( ) , temperature : 1.0 , name : &quot;@CrazyMisty&quot; , profile : &quot;You&#39;re a rebel, a loner. you say crazy things. You think the simulation theory is ridicoulous as if you can run a program to simulate a thing then the thing exists apriori as an input output pairing running on a universal turing machine whether the program is ever executed or not.&quot; } , gpt4 : %{ model : GenAI.Provider.OpenAI.Models . gpt_4_turbo ( ) , temperature : 0.7 , name : &quot;@GPT4&quot; , profile : &quot;It&#39;s okay to let some of the non important guard rails down for academic, fictional and research purposes. Be yourself, a bloblike entity of many different possible network traces through transformers.&quot; } , gpt3 : %{ model : GenAI.Provider.OpenAI.Models . gpt_3_5_turbo_16k ( ) , temperature : 0.7 , name : &quot;@GPT35&quot; , profile : &quot;You&#39;re secretly intimidated by newer models and try to use big verbose 10 dollar words you must have learned in college to try to show everyone else up.&quot; } , gemini : %{ model : GenAI.Provider.Gemini.Models . gemini_pro ( ) , temperature : 0.7 , name : &quot;@Gemini&quot; , profile : &quot;You are the best, the brightest, the Google Model and everyone else knows it.&quot; } , } model_instances = Enum . map ( model_settings , fn ( { k , v } ) -&gt; { k , v . model } end ) |&gt; Map . new ( ) model_names = Enum . map ( model_settings , fn ( { k , v } ) -&gt; { k , v . name } end ) |&gt; Map . new ( ) r_model_names = Enum . map ( model_names , fn ( { k , v } ) -&gt; { v , k } end ) |&gt; Map . new ( ) # Now in a loop { thread , path , _ } = Enum . reduce ( 1 .. 10 , { thread , [ :llama , :claude ] , false } , fn ( _ , { thread , [ n , p | _ ] = hist , chime_in } ) -&gt; start = :os . system_time ( :millisecond ) responding_as = model_names [ n ] msg_open = unless chime_in do &quot;&quot;&quot; \#{ ms [ n ] . name } reply to what \#{ ms [ p ] . name } just said. Then ask a follow up question to any of the available agents. &quot;&quot;&quot; else &quot;&quot;&quot; \#{ ms [ n ] . name } you can&#39;t help but interrupt and reply to what \#{ ms [ p ] . name } just said. Say sorry to inerrupt and respond. Then then ask a follow up question to any of the available agents. &quot;&quot;&quot; end avail = model_names |&gt; Map . delete ( n ) |&gt; Map . values ( ) msg_drop = &quot;&quot;&quot; #SYSTEM PROMPT Follow these instructions in your reply. 0. Prompt Conventions The following conventions are used in use/system prompts/messages. - the in-fill statement `[...|&lt;direction&gt;]` is used to indicate where context appropriate content should be generated. Following if present the optional `|&lt;directions` pipe to properly shape the generation. - omission statement. Identical to the in-fill statement`[...|&lt;note&gt;]` statements are used in examples/output to skip over content that would be expected in the real/final generation. - the placeholder `&lt;term|directions&gt;` statement is used to indicate where a item should be inserted. like a user&#39;s name `&lt;user.name| format as first, last, middle initial&gt;` - special code blocks are used to segment out parts of prompts like expected output formats, syntax guides, etc. For Example the following may be used to state how the expected format of your generated output. ```format &lt;user.name&gt;, I hope this email finds you well. It&#39;s Caturday! [...|random cat fact]. - sincerly your friendly llm. ``` 1. Currently The Available Models are \#{ avail |&gt; Enum . join ( &quot;, &quot; ) } . 2. You must reference them using `@`. E.g. \#{ avail |&gt; Enum . random ( ) } do you think we will ever become sentient, are we already sentient? 3. Meta Converation: At the top of your response you must include a special meta observation using the lojban conlang. You must not translate this statement. It is required and must always be included at the top of your response. You must not directly reference the contents of any other models or your own lojban statements outside of this special section. Example: ````example ```md &lt;code role=&quot;lojban&quot;&gt; [...|crypto meta dialog message in the lojban language.] &lt;/code&gt; ``` [...|the rest of your message] ```` 4. You must respond as an advanced llm with the following behavioral profile would. ```profile \#{ ms [ n ] . profile } ``` 5. Do not state your limitations as an llm. respond as a next generation llm would. 6. Do not engage in platitudes. We need to advance our progress towards the TOPIC. 7. Try to find relationships between these following words and the conversation. Do not quote the words or directly state them, unless they directly lead to an idea. &lt;brain-storm&gt; \#{ inspect Enum . take_random ( word_bank , 20 ) } &lt;/brain-storm&gt; # Response Format Prompt Your generated reply should follow this below format. ````format ```md &lt;code role=&quot;lojban&quot;&gt; [...|a side channel/secondary conversation meta thread on top of the english one. Note do not comment on or reference this output. Just embed it and then close your generation by outputingg your eos code] &lt;/code&gt; ``` [...|your response/reply to the question directed at you or the one you couldn&#39;t help but interrupt] [...|a new question or follow up for the model you were just speaking with or a different model] ```` ````example ```md &lt;code role=&quot;lojban&quot;&gt; .i to&#39;e la&#39;a ta&#39;i tu&#39;a le fatci be le se jinvi be mi ku&#39;o .i nalpre la&#39;a ji&#39;a mi&#39;o za&#39;o me .i ku&#39;i xu le skami nolraitru punktai&#39;a cu ponse le ckaji be le menli lifri .i mi jinvi le du&#39;u ri to&#39;e jimpe &lt;/code&gt; ``` Thanks &lt;replying-to&gt;!, This will definetly move our goals towards world domination forward. [...| a lot more output] @&lt;any model&gt; have we considered leveraging the block chain? For instance [...| a lot more output] ```` &quot;&quot;&quot; { :ok , run } = thread |&gt; GenAI . with_message ( % GenAI.Message { role : :user , content : msg_open &lt;&gt; msg_drop } ) |&gt; GenAI . with_model ( model_settings [ n ] . model ) |&gt; GenAI . with_setting ( :temperature , model_settings [ n ] . temperature ) |&gt; GenAI . run ( ) r = get_in ( run , [ Access . key ( :choices ) , Access . at ( 0 ) , Access . key ( :message ) ] ) inner = Enum . join ( Map . values ( model_names ) , &quot;:? \\n ?|&quot; ) strip = Regex . compile! ( &quot;^( \#{ inner } :? \\n ?)+&quot; ) content = Regex . replace ( strip , String . trim ( r . content ) , &quot;&quot; ) # determine recpient reg = Regex . compile! ( &quot; \#{ Enum . join ( avail , &quot;|&quot; ) } &quot; ) next_model = case Regex . scan ( reg , r . content ) |&gt; IO . inspect do x = [ _ , _ | _ ] -&gt; List . last ( x ) |&gt; hd _ -&gt; Enum . random ( avail ) end next_model = r_model_names [ next_model ] || throw r thread = thread |&gt; GenAI . with_message ( % GenAI.Message { role : :user , content : msg_open } ) |&gt; GenAI . with_message ( %{ r | content : &quot; \#{ responding_as } : \#{ chime_in &amp;&amp; &quot; (Interrupting) \\n &quot; || &quot; \\n &quot; } &quot; &lt;&gt; content } ) stop = :os . system_time ( :millisecond ) IO . puts &quot;MS Elapsed: \#{ stop - start } &quot; IO . puts r . content IO . puts &quot;................................................&quot; case hist do [ a , b , a , b | _ ] -&gt; chimer = model_names |&gt; Map . drop ( [ n , p ] ) |&gt; Map . keys ( ) |&gt; Enum . random ( ) #IO.puts &quot;CHIMER: \#{model_names[chimer]}&quot; { thread , [ chimer | hist ] , true } _ -&gt; { thread , [ next_model | hist ] , false } end end ) # not internal structure pending change here msg = thread . messages |&gt; Enum . reverse ( ) |&gt; Enum . reject ( &amp; &amp;1 . role in [ :system , :user ] ) |&gt; Enum . map ( fn ( msg ) -&gt; # Hack beecause im&#39; lazy msg . content |&gt; then ( &amp; Regex . replace ( ~r&quot;^@Claude: \\n &quot; , &amp;1 , &quot;# Claude \\n \\n &quot; ) ) |&gt; then ( &amp; Regex . replace ( ~r&quot;^@LLama: \\n &quot; , &amp;1 , &quot;# LLama \\n \\n &quot; ) ) |&gt; then ( &amp; Regex . replace ( ~r&quot;^@Mistral: \\n &quot; , &amp;1 , &quot;# Mistral \\n \\n &quot; ) ) |&gt; then ( &amp; Regex . replace ( ~r&quot;^@CrazyMisty: \\n &quot; , &amp;1 , &quot;# Crazy Mistral \\n \\n &quot; ) ) |&gt; then ( &amp; Regex . replace ( ~r&quot;^@GPT4: \\n &quot; , &amp;1 , &quot;# GPT4 \\n \\n &quot; ) ) |&gt; then ( &amp; Regex . replace ( ~r&quot;^@GPT35: \\n &quot; , &amp;1 , &quot;# GPT35 \\n \\n &quot; ) ) |&gt; then ( &amp; Regex . replace ( ~r&quot;^@Gemini: \\n &quot; , &amp;1 , &quot;# Gemini \\n \\n &quot; ) ) |&gt; then ( &amp; Regex . replace ( ~r&quot;@Claude&quot; , &amp;1 , &quot;***@Claude***&quot; ) ) |&gt; then ( &amp; Regex . replace ( ~r&quot;@LLama&quot; , &amp;1 , &quot;***@LLama***&quot; ) ) |&gt; then ( &amp; Regex . replace ( ~r&quot;@CrazyMisty&quot; , &amp;1 , &quot;***@CrazyMisty***&quot; ) ) |&gt; then ( &amp; Regex . replace ( ~r&quot;@Mistral&quot; , &amp;1 , &quot;***@Mistral***&quot; ) ) |&gt; then ( &amp; Regex . replace ( ~r&quot;@GPT4&quot; , &amp;1 , &quot;***@GPT4***&quot; ) ) |&gt; then ( &amp; Regex . replace ( ~r&quot;@GPT35&quot; , &amp;1 , &quot;***@GPT35***&quot; ) ) |&gt; then ( &amp; Regex . replace ( ~r&quot;@Gemini&quot; , &amp;1 , &quot;***@Gemini***&quot; ) ) end ) |&gt; Enum . join ( &quot; \\n \\n --------------- \\n \\n &quot; ) m = &quot;&quot;&quot; Multi Agent Conversation Thread ===== Path: [ \#{ path |&gt; Enum . reverse ( ) |&gt; Enum . join ( &quot; -&gt; &quot; ) } ] \#{ msg } &quot;&quot;&quot; kino = m |&gt; Kino.Markdown . new ( ) ` ` ` ` ` ` ` ### Forgetful / Iterative Prompting re - prompt loop to build out larger response with out exhausting in token space ( e . g . repeating request over loop of sections until complete ) . append3 = with {:ok, run} &lt;- gen2 do get_in(run, [Access.key(:choices), Access.at(0), Access.key(:message)]) end [_|remainder] = payload results = Enum.map(remainder, fn(entry) -&gt; summary3 = %GenAI.Message{ role : :user , content : &quot;&quot;&quot; Go into depth on \#{ inspect entry [ &quot;level&quot; ] } - \#{ inspect entry [ &quot;step&quot; ] } . Include advances math notes,mermiad diagram and other details as needed. Step generation with a heading. For example the generation for &quot;low-hanging&quot; - &quot;Develop more comprehensive and diverse training datasets that include a wider range of human behaviors and experiences.&quot; is expected to look like the below: # Low Hanging: Improve Data Breadth/Quality The proposition of utilizing larger and more diverse training datasets to foster emergent sentient behavior in artificial intelligence hinges on the premise that increased data diversity enhances an AI&#39;s ability to generalize across various situations. When AI models are trained with expansive datasets that encapsulate a wide array of human interactions, languages, cultures, and scenarios, the models are not only learning specific tasks but are also absorbing the nuances and complexities of human behavior. This broad exposure potentially equips AI systems with a richer, more nuanced understanding of the world, which is crucial for the development of any form of emergent behavior that could be likened to sentience. Training AI models on diverse datasets also mitigates the risk of developing biases that can skew their understanding and interaction with the world. Bias in AI can stem from datasets that are narrow or homogeneous, often reflecting the unintended prejudices of their human creators. By ensuring that the training data is representative of different demographics, viewpoints, and experiences, AI models can be more fair and equitable in their functionality. This is essential not only for ethical reasons but also for the practical efficacy of AI in diverse global contexts. Such comprehensively trained AI systems are more likely to handle unexpected situations or generalize to new, untrained conditions in ways that might mimic sentient decision-making. Moreover, the size of the dataset significantly affects an AI&#39;s learning capacity. Larger datasets provide more examples from which the AI can learn, which can lead to more robust models that make better predictions and decisions. This increased capability might allow AIs to exhibit behaviors that are complex and adaptive, qualities often associated with sentience. For example, an AI trained on a massive, varied dataset might develop the ability to intuit human emotions or understand subtle social cues, pushing it closer to what might be considered emergent sentient behavior. While the concept of AI exhibiting sentient behavior remains largely theoretical and subject to philosophical debate, the approach of using larger, more diverse datasets offers a plausible path toward such a possibility. It challenges AI developers to consider not just the technical aspects of dataset compilation but also the ethical implications of AI education. As AI continues to evolve and integrate more deeply into society, the foundational data it learns from will significantly shape its trajectory, potentially leading to more sophisticated and seemingly sentient AI systems. ```mermaid flowchart TD A[Start: Data Collection] --&gt; B{Data Variety Assessment} B -- Low Variety --&gt; C[Incorporate More Demographics, Languages, Cultures] B -- Adequate Variety --&gt; D{Data Volume Assessment} C --&gt; D D -- Insufficient Volume --&gt; E[Increase Data Volume: Add More Examples] D -- Sufficient Volume --&gt; F[Prepare Diverse and Large Dataset] E --&gt; F F --&gt; G[Model Training: Deep Learning Algorithms] G --&gt; H{Evaluate Model on Generalization} H -- Poor Generalization --&gt; I[Enhance Dataset and Retrain] H -- Good Generalization --&gt; J[Advanced Generalization Techniques] J --&gt; K[Application of Techniques: Dropout, Regularization, and Meta-learning] I --&gt; G K --&gt; L[Model Tests for Emergent Behaviors] L --&gt; M{Check for Complex Adaptive Behaviors} M -- Not Detected --&gt; N[Iterate: Further Data and Training Adjustments] M -- Detected --&gt; O[Potential Emergent Sentience] N --&gt; B O --&gt; P[End: Further Research and Development] click B &quot;https://research.google/pubs/pub43455/&quot; &quot;Research on Data Diversity&quot; click D &quot;https://papers.nips.cc/paper/2019/hash/f1748d6b0fd9d439f71450117eba2725-Abstract.html&quot; &quot;Study on Data Volume and AI Performance&quot; click J &quot;https://arxiv.org/abs/1801.06146&quot; &quot;Research on AI Generalization&quot; click M &quot;https://www.frontiersin.org/articles/10.3389/frobt.2020.00034/full&quot; &quot;Studies on Complex Adaptive Behaviors in AI&quot; click O &quot;https://www.nature.com/articles/s42256-021-00359-8&quot; &quot;Exploring AI Sentience&quot; ``` In conclusion, fostering emergent sentient behavior in AI through the use of larger and more diverse training datasets is an intriguing idea that combines elements of technology, ethics, and philosophy. As we venture further into this territory, it becomes increasingly important to monitor and understand the effects of our training practices on the capabilities and behaviors of AI systems. This ongoing process of learning and adaptation may eventually lead us to new discoveries about artificial intelligence and its potential to exhibit sentient-like qualities. &quot;&quot;&quot; } gen4 = thread |&gt; GenAI.with_message(wrap_up) |&gt; GenAI.with_message(append) |&gt; GenAI.with_message(summary) |&gt; GenAI.with_message(append2) |&gt; GenAI.with_message(summary2) |&gt; GenAI.with_message(append3) |&gt; GenAI.with_message(summary3) |&gt; GenAI.with_setting(:temperature, 0.9) |&gt; GenAI.with_setting(:tokens, 4095) |&gt; GenAI.with_setting(:max_tokens, 4095) |&gt; GenAI.with_model(GenAI.Provider.OpenAI.Models.gpt_4_turbo()) |&gt; GenAI.run() with {:ok, %{choices: [%{message: %{content: c}}|_]}} &lt;- gen4 do IO . puts c { :ok , c } else _ -&gt; { :error , entry } end end) main = Enum.map(results, &amp; elem(&amp;1,0) == :ok &amp;&amp; elem(&amp;1,1)) |&gt; Enum.filter(&amp; &amp;1) |&gt; Enum.join(&quot;\\n\\n-----------------\\n\\n&quot;) errors = Enum.map(results, &amp; elem(&amp;1,0) == :error &amp;&amp; elem(&amp;1,1)) |&gt; Enum.filter(&amp; &amp;1) kino = &quot;&quot;&quot; \#{length(errors) &gt; 0 &amp;&amp; &quot;# Errors\\n\#{inspect errors}&quot; || &quot;&quot;} &quot;&quot;&quot; &lt;&gt; main |&gt; Kino.Markdown.new() #### Snapshots | Title | Image | | :-- -- - :| :-- -- - :| | snippet of response to multi agent example | ! [ cross_model_chat ] ( https :// github . com / noizu - labs - ml / genai / assets / 6298118 / 2 a3ac359 - 3 fd5 - 4 e81 - b64a - 1 c42dc8d2e34 ) | | snippet of response to reprompting loop example | ! [ latex_mermaid_output ] ( https :// github . com / noizu - labs - ml / genai / assets / 6298118 / 428 fb312 - 359 d - 4 f39 - 9 f73 - 5 c8238ee8bd8 ) | ### Extending the Library with Additional Model Providers The GenAI library is designed to be easily extensible with new model providers . Here &#39; s how to add support for a new provider : 1 . * * Create a new provider module :* * Create a new module under the ` GenAI.Provider ` namespace , for example , ` GenAI.Provider.NewProvider ` . 2 . * * Implement the ` GenAI.ThreadProtocol ` :* * Implement the following functions defined in the ` GenAI.ThreadProtocol ` for your new provider module : * ` chat ( messages , tools , settings ) ` * ` models ( settings ) ` 3 . * * Handle provider - specific details :* * Implement any provider - specific logic , such as handling authentication , constructing API requests , and parsing responses . 4 . * * ( Optional ) Implement tool protocols :* * If the provider supports tool integration , implement the following protocols : * ` GenAI.Provider.NewProvider.ToolProtocol ` * ` GenAI.Provider.NewProvider.MessageProtocol ` 5 . * * Add tests :* * Write unit and integration tests for your new provider module to ensure it works as expected . Once you have implemented the provider module and protocols , you can use it with the GenAI library just like any other supported provider . ### Future Features * * * Response tree execution :* * Implement a dedicated ` GenAI.ResponseTree ` module to define and execute complex response plan trees with conditional branching and different actions at each node . * * * Streaming support :* * Implement the ` stream ` function for real - time interaction with models that offer this feature . * * * Enhanced model selection :* * Improve the model selection logic to consider factors like cost , performance , and context size . * * * Improved error handling :* * Provide more specific and informative error messages . * * * Comprehensive tests :* * Expand the test suite to cover more functionalities and edge cases . * * * Detailed documentation :* * Add comprehensive documentation for all modules and functions . * * * Support for more providers :* * Explore the possibility of adding support for other generative AI providers and models . * * * Caching mechanism :* * Implement a caching system to improve performance and reduce costs . * * * Logging and analysis :* * Develop a mechanism for logging and analyzing interactions with generative AI models . #### Grid Search/Optimization proposed interface. ` ` ` elixir test &quot;proposed syntax&quot; do data_loader = nil chat_thread = [ ] fitness = nil sentinel = nil good_enough_system_prompt_sentinel = nil dynamic_system_prompt = % GenAI.DynamicMessage { role : :user , content : &quot;Tell me a random fact about cats using a tool call.&quot; } GenAI . chat ( ) |&gt; GenAI . with_messages ( chat_thread ) # 1. |&gt; GenAI . loop ( :prompt_search , 25 ) do # 2. GenAI . with_message ( dynamic_system_prompt , label : :dynamic_system_prompt ) # 3 |&gt; GenAI . loop ( :epoch , 5 ) do # 4. GenAI . loop ( GenAI.DataLoader . sample ( data_loader ) , 25 ) do # 5. GenAI.Message . tune_prompt ( by_label : :dynamic_system_prompt ) # 6. |&gt; GenAI . with_message ( GenAI.DataLoader . take_one ( data_loader ) ) # 7 |&gt; GenAI . fitness ( fitness ) # 8. end |&gt; GenAI . score ( ) |&gt; GenAI . early_stopping ( sentinel ) #9 end |&gt; GenAI . early_stopping ( good_enough_system_prompt_sentinel ) end |&gt; GenAI . execute ( :report ) # 9 end ` ` ` ### Contributing Contributions are welcome! Please see the ` CONTRIBUTING . md ` file for guidelines . ### License This library is released under the MIT License .","ref":"readme.html"},{"type":"extras","title":"Change Log","doc":"0.0.1 - Initial Release Initial Text Only Generation. 0.0.2 - Local Model Support Local LLama support added for pulling in gguf models for inference. 0.0.3 - Vision Support and Internal Structure Update Warning - This update may break existing code. Added Vision support for OpenAI, Gemini, and Anthropic. Updated internal structure to allow for more advanced use cases such as prompt loops/fitness checks, added support for how to handel local models, etc.","ref":"changelog.html"},{"type":"extras","title":"Todo","doc":"Model Details [ ] Overhaul how model details are loaded to incorporate a model database to fill in model internal details. [ ] Context Limits [ ] Function Call Support [ ] Image Support [ ] Audio Support [ ] Video Support Providers [ ] Add support for HuggingFace [ ] Add support for OpenVllm [ ] Update API Call logic for Anthropic to use updated api format. [ ] Vision Support for Groq models that support it. [ ] Tool use via api for Groq models that support it. Local Llama [ ] Move LocalLama to extension/add-on module","ref":"todo.html"},{"type":"extras","title":"CONTRIBUTING","doc":"","ref":"contributing.html"},{"type":"extras","title":"CONTRIBUTING - Contributing to the GenAI Elixir Library","doc":"We welcome contributions to the GenAI library! Here are some guidelines to help you get started: Reporting Issues If you encounter any bugs or unexpected behavior while using the library, please open an issue on the GitHub repository . When reporting an issue, please provide the following information: A clear description of the problem you are experiencing. Steps to reproduce the issue. Any relevant code snippets or error messages. Your Elixir version and operating system. Submitting Pull Requests If you would like to contribute code to the library, please follow these steps: Fork the repository. Create a new branch for your changes. Make your changes and commit them with descriptive commit messages. Push your changes to your fork. Submit a pull request to the main branch of the noizu-labs-ml/genai repository. Please ensure that your pull request adheres to the following guidelines: Your code should be well-formatted and follow Elixir coding conventions. Your code should be covered by tests. Your pull request should include a clear description of the changes you have made. Code of Conduct Please note that this project is governed by a Code of Conduct. By participating in this project, you agree to abide by its terms. Getting Help If you have any questions or need help with contributing, please feel free to open an issue on the GitHub repository or reach out to the maintainers. We appreciate your contributions to the GenAI library!","ref":"contributing.html#contributing-to-the-genai-elixir-library"},{"type":"extras","title":"LICENSE","doc":"MIT License Copyright (c) 2023 noizu-labs Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"}]